/*
 * Created on 13 fvr. 2005
 *
 */

/**
 * @author remi
 *
 */
public class CalculTaxe {
  
  // doit tre public pour tre appelable de partout
  // doit tre statique car est appel sur la classe
  public static int calculTaxe(Immatriculation imat){
    String dep= imat.getDepartement();
    
    // ici deux solution d'algorithme, soit on rcupre les
    // deux caractres puis on les transforme en faisant attention
    // au 2A/2B
    /*
    char c1=dep.charAt(0);
    char c2=dep.charAt(1);
    
    if (c1=='2' && (c2=='A' || c2=='B'))
      return 2;
    
    // on utilise le fait que les chiffres se suivent
    // en unicode
    return c1-'0'+c2-'0';
    */
    
    // autre solution, on utilise Integer.parseInt()
    // puis on extrait le chiffre des dixaines et des units
    // s'il y a une erreur, cela doit tre 2A/2B
    
    try {
      int value=Integer.parseInt(dep);
      
      // on extrait la dixine et l'unit
      return value/10+value%10;
    } catch(NumberFormatException e) {
      // nous somme dans le cas ou parseInt  rat
      
      // test 2A et 2B sur les chaines de caractre
      // on crit "2A".equals(dep) plutt que dep.equals("2A")
      // car le premier appel marche aussi si dep est null
      if ("2A".equals(dep) || "2B".equals(dep))
        return 2;
      
      // ne devrait pas arriv
      throw new AssertionError("nom de dpartement illgal "+dep);
    }
  }
  
  // permet de calculer la taxe pour une Voiture ou un camion
  // car Camion est un sous-type de Voiture (par hritage)
  public static double calculTaxe(Voiture voiture){
    // la taxe est calcule en fonction de l'immatriculation et d'un facteur
    // multiplicatif dpendant de si la voiture est une voiture ou un camion
    // on utilise le polymorphisme lors de l'appel  facteurTaxe() ce qui
    // permet d'appeler la mthode Voiture.facteurTaxe() ou Camion.facteurTaxe()
    // en fonction du type rel de Voiture
    return calculTaxe(voiture.getImmatriculation())*voiture.facteurTaxe();
  }
}
