/*
 * Created on 13 fvr. 2005
 *
 */

/**
 * @author remi
 *
 */
public class Parking {
  // false indique une place libre, true une place occupe
  private final boolean[] placeOccupees;
  
  public Parking(int capacite) {
    placeOccupees=new boolean[capacite];
  }
  
  public int reserve() {
    for(int i=0;i<placeOccupees.length;i++)
      if (!placeOccupees[i]) {
        placeOccupees[i]=true;
        return i;
      }
        
    throw new RuntimeException();
  }
  
  public void libere(int index) {
    if (!placeOccupees[index])
      throw new RuntimeException();
    placeOccupees[index]=false;
  }
  
  public @Override String toString() {
    StringBuilder builder=new StringBuilder();
    builder.append("capacit ").append(placeOccupees.length);
    for(int i=0;i<placeOccupees.length;i++) {
      builder.append(i).append(placeOccupees[i]?": occup":": libre");
    }
    return builder.toString();
  }
  
  public int nbrPlaceLibre() {
    int count=0;
    for(boolean place:placeOccupees)
      if (!place)
        count++;
    return count;
  }
}
